Linode Debian + rvm + nginx + Unicorn tue le maître au démarrage ou ne commence pas unicorn

Je suis un nouvel user de Linode / Linux qui exécute Debian 6. J'essaie d'get mon server Unicorn pour démarrer au démarrage, mais pour une raison quelconque, ce n'est pas le cas, et je ne peux pas refind aucun message d'erreur. Nginx démarre bien, et j'ai une installation RVM multi-user. J'ai l'printing que cela a quelque chose à voir avec RVM. C'est mon file unicorn_init.sh dans /rails/todo , et il y a un lien symbolique dans /etc/init.d/unicorn :

 # unicorn_init.sh #!/bin/sh set -e TIMEOUT=${TIMEOUT-60} APP_ROOT=/rails/todo PID=$APP_ROOT/tmp/pids/unicorn.pid CMD="$APP_ROOT/bin/unicorn_rails -D -c $APP_ROOT/config/unicorn.rb -E production" GEM_HOME="/usr/local/rvm/gems/ruby-1.9.2-p290@global" action="$1" set -u old_id="$PID.oldbin" cd $APP_ROOT || exit 1 export GEM_HOME=$GEM_HOME sig () { test -s "$PID" && kill -$1 `cat $PID` } oldsig () { test -s $old_pid && kill -$1 `cat $old_pid` } case $action in start) sig 0 && echo >&2 "Already running" && exit 0 su -c "$CMD" - root ;; stop) sig QUIT && exit 0 echo >&2 "Not running" ;; force-stop) sig TERM && exit 0 echo >&2 "Not running" ;; restart|reload) sig HUP && echo reloaded OK && exit 0 echo >&2 "Couldn't reload, starting '$CMD' instead" su -c "$CMD" - root ;; upgrade) if sig USR2 && sleep 2 && sig 0 && oldsig QUIT then n=$TIMEOUT while test -s $old_pid && test $n -ge 0 do printf '.' && sleep 1 && n=$(( $n - 1 )) done echo if test $n -lt 0 && test -s $old_pid then echo >&2 "$old_pid still exists after $TIMEOUT seconds" exit 1 fi exit 0 fi echo >&2 "Couldn't upgrade, starting '$CMD' instead" su -c "$CMD" - root ;; reopen-logs) sig USR1 ;; *) echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>" exit 1 ;; esac 

Je suis à 99% de la façon de faire fonctionner mon installation. Tout conseil serait très apprécié.


Mettre à jour

Voici la sortie de $ update-rc.d unicorn defaults :

 update-rc.d: using dependency based boot sequencing insserv: warning: script 'unicorn' missing LSB tags and overrides insserv: There is a loop between service nginx and unicorn if stopped insserv: loop involving service unicorn at depth 2 insserv: loop involving service nginx at depth 1 insserv: Stopping unicorn depends on nginx and therefore on system facility `$all' which can not be true! insserv: exiting now without changing boot order! update-rc.d: error: insserv rejected the script header 

One Solution collect form web for “Linode Debian + rvm + nginx + Unicorn tue le maître au démarrage ou ne commence pas unicorn”

Shebang ( #!/bin/sh ) devrait être la première ligne du script

Édité:

Mettez le suivi après le shebang et avant tout paramètre spécifique à l'application

 ### BEGIN INIT INFO # Provides: APPLICATION # Required-Start: $all # Required-Stop: $network $local_fs $syslog # Default-Start: 2 3 4 5 # Default-Stop: 0 1 6 # Short-Description: Start the APPLICATION unicorns at boot # Description: Enable APPLICATION at boot time. ### END INIT INFO # # Use this as a basis for your own Unicorn init script. # Make sure that all paths are correct. set -u set -e 

Il devrait certainement se débarrasser des avertissements LSB.

  • Nginx peut-il fonctionner à la fois pour gitlab et taiga.io sur la même machine virtuelle?
  • Ruby: Est-il logique d'utiliser REE avec Unicorn?
  • La dernière source GitHub n'est pas déployée correctement par Opsworks
  • 502 mauvaises erreurs de passerelle après 68 users simultanés sur le site Web
  • Les travailleurs de licorne disparaissent
  • Comment puis-je configurer nginx pour servir des hotes virtuels avec des rails (licorne / passager) et php-fpm
  • Comment définir différents signaux d'arrêt / redémarrage avec démarrage
  • Erreurs d'attaque de spoofing IP après la configuration d'un nodebalancer sur Linode.com
  • Nginx + unicorn + spdy + test de performance
  • Problème avec la configuration nginx et les servers en amont
  • Nginx Returning 504 Error
  • Les astuces du serveur de linux et windows, tels que ubuntu, centos, apache, nginx, debian et des sujets de rĂ©seau.